SystemOrganization addCategory: #'Pier-Scriptaculous'!

PRTreeWidget subclass: #PRTreeSUWidget
	instanceVariableNames: 'cssId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Scriptaculous'!

!PRTreeSUWidget class methodsFor: 'as yet unclassified' stamp: 'tg 11/17/2007 22:52'!
defaultLevel
	^ 1! !

!PRTreeSUWidget class methodsFor: 'as yet unclassified' stamp: 'tg 11/17/2007 22:52'!
descriptionLevel
	^ MANumberDescription new
		default: self defaultLevel;
		selectorAccessor: #level;
		label: 'Level';
		priority: 300;
		beInteger;
		min: 1;
		yourself! !

!PRTreeSUWidget class methodsFor: 'as yet unclassified' stamp: 'tg 11/17/2007 22:51'!
descriptionShowRoot
	^ MABooleanDescription new
		selectorAccessor: #showRoot;
		label: 'Show Root';
		priority: 4200;
		default: true;
		yourself! !

!PRTreeSUWidget class methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 04:55'!
label
	^ 'TreeSU'! !

!PRTreeSUWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 04:38'!
cssId

	^ cssId! !

!PRTreeSUWidget methodsFor: 'as yet unclassified' stamp: 'tg 11/17/2007 22:46'!
level
	^ (self read: #descriptionLevel) ifNil: [1]! !

!PRTreeSUWidget methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 04:38'!
renderContentOn: html
	html div 
		id: (cssId := html nextId);
		with: [ self updateContentOn: html ]! !

!PRTreeSUWidget methodsFor: 'as yet unclassified' stamp: 'tg 11/10/2007 22:31'!
renderStructureButton: aStructure on: html
	| isExpanded |
	html span class: 'button'; with: [
		(self childrenOf: aStructure) isEmpty
			ifTrue: [ html space ]
			ifFalse: [
				isExpanded _ self isExpanded: aStructure.
				html anchor
					onClick: (html updater
								id: (self cssId);
								callback: [ :r |
									isExpanded
										ifTrue: [ self collapseStructure: aStructure ]
										ifFalse: [ self expandStructure: aStructure ].
									self updateContentOn: r ]	
							);
					with: (isExpanded
						ifTrue: [ '-' ]
						ifFalse: [ '+' ]) ] ]! !

!PRTreeSUWidget methodsFor: 'as yet unclassified' stamp: 'tg 11/17/2007 22:50'!
showRoot
	^ self read: #descriptionShowRoot! !

!PRTreeSUWidget methodsFor: 'as yet unclassified' stamp: 'tg 11/17/2007 22:58'!
updateContentOn: html

	| structure |
	
	structure _ self context structure.
	[structure isRoot not and: [structure parent isRoot not]] 
		whileTrue: [structure _ structure parent].

	structure _ self context structure parents
			at: self level
			ifAbsent: [#()].

	(self childrenOf: structure) isEmpty ifFalse: [
		self showRoot
			ifTrue: [html unorderedList with: [self renderStructure: structure on: html]]
			ifFalse: [self renderStructureChildren: structure on: html ]
	]! !
